## TomoeDict

TomoeDict — An object of dictionary.

## Synopsis

                        TomoeDict;
    void                tomoe_dict_init                     (void);
    void                tomoe_dict_quit                     (void);
    const gchar*        tomoe_dict_get_default_module_dir   (void);
    void                tomoe_dict_set_default_module_dir   (const gchar *dir);
    void                tomoe_dict_load                     (const gchar *base_dir);
    TomoeModule*        tomoe_dict_load_module              (const gchar *name);
    void                tomoe_dict_unload                   (void);
    GList*              tomoe_dict_get_registered_types     (void);
    GList*              tomoe_dict_get_log_domains          (void);
    TomoeDict*          tomoe_dict_new                      (const gchar *name,
                                                             const gchar *first_property,
                                                             ...);
    const gchar*        tomoe_dict_get_name                 (TomoeDict *dict);
    gboolean            tomoe_dict_register_char            (TomoeDict *dict,
                                                             TomoeChar *chr);
    gboolean            tomoe_dict_unregister_char          (TomoeDict *dict,
                                                             const gchar *utf8);
    TomoeChar*          tomoe_dict_get_char                 (TomoeDict *dict,
                                                             const gchar *utf8);
    GList*              tomoe_dict_search                   (TomoeDict *dict,
                                                             TomoeQuery *query);
    gboolean            tomoe_dict_flush                    (TomoeDict *dict);
    gboolean            tomoe_dict_is_editable              (TomoeDict *dict);
    gboolean            tomoe_dict_is_available             (TomoeDict *dict);
    gchar*              tomoe_dict_get_available_private_utf8
                                                            (TomoeDict *dict);

## Object Hierarchy

      GObject
       +----TomoeDict

## Description

## Details

### TomoeDict

    typedef struct _TomoeDict TomoeDict;

The TomoeDict struct contains only private fields and should not be directly accessed.

### tomoe_dict_init ()

    void                tomoe_dict_init                     (void);

### tomoe_dict_quit ()

    void                tomoe_dict_quit                     (void);

### tomoe_dict_get_default_module_dir ()

    const gchar*        tomoe_dict_get_default_module_dir   (void);

Returns : |

### tomoe_dict_set_default_module_dir ()

    void                tomoe_dict_set_default_module_dir   (const gchar *dir);

`dir` : |

### tomoe_dict_load ()

    void                tomoe_dict_load                     (const gchar *base_dir);

`base_dir` : |

### tomoe_dict_load_module ()

    TomoeModule*        tomoe_dict_load_module              (const gchar *name);

`name` : |
Returns : |

### tomoe_dict_unload ()

    void                tomoe_dict_unload                   (void);

### tomoe_dict_get_registered_types ()

    GList*              tomoe_dict_get_registered_types     (void);

Returns : |

### tomoe_dict_get_log_domains ()

    GList*              tomoe_dict_get_log_domains          (void);

Returns : |

### tomoe_dict_new ()

    TomoeDict*          tomoe_dict_new                      (const gchar *name,
                                                             const gchar *first_property,
                                                             ...);

Create a new TomoeDict.

`name` : | The name of dictionary type.
`first_property` : | the name of the first property.
`...` : | the value of the first property, followed optionally by more name/value pairs, followed by NULL
Returns : | a new TomoeDict.

### tomoe_dict_get_name ()

    const gchar*        tomoe_dict_get_name                 (TomoeDict *dict);

Get the dictionary name.

`dict` : | a TomoeDict.
Returns : | the name of the dictionary.

### tomoe_dict_register_char ()

    gboolean            tomoe_dict_register_char            (TomoeDict *dict,
                                                             TomoeChar *chr);

Register a TomoeChar object.

`dict` : | a TomoeDict object.
`chr` : | a TomoeChar object to register.
Returns : | TRUE if success.

### tomoe_dict_unregister_char ()

    gboolean            tomoe_dict_unregister_char          (TomoeDict *dict,
                                                             const gchar *utf8);

Unregister a TomoeChar object which has utf8 code point.

`dict` : | a TomoeDict object.
`utf8` : | UTF-8 encoded value of the character.
Returns : | TRUE if success.

### tomoe_dict_get_char ()

    TomoeChar*          tomoe_dict_get_char                 (TomoeDict *dict,
                                                             const gchar *utf8);

Get a TomoeChar object which has utf8 code point

`dict` : | a TomoeDict object.
`utf8` : | UTF-8 encoded value of the character.
Returns : | a TomoeChar object.

### tomoe_dict_search ()

    GList*              tomoe_dict_search                   (TomoeDict *dict,
                                                             TomoeQuery *query);

`dict` : |
`query` : |
Returns : |

### tomoe_dict_flush ()

    gboolean            tomoe_dict_flush                    (TomoeDict *dict);

`dict` : |
Returns : |

### tomoe_dict_is_editable ()

    gboolean            tomoe_dict_is_editable              (TomoeDict *dict);

`dict` : |
Returns : |

### tomoe_dict_is_available ()

    gboolean            tomoe_dict_is_available             (TomoeDict *dict);

`dict` : |
Returns : |

### tomoe_dict_get_available_private_utf8 ()

    gchar*              tomoe_dict_get_available_private_utf8
                                                            (TomoeDict *dict);

`dict` : |
Returns : |